;; local keys

;; KEYS
(global-set-key "\M-g"      'goto-line)
; (global-set-key "\C-x="     'WhatCursorPosition)
; (global-set-key "\C-c\C-c"  'compile)
; (global-set-key "\M-z"      'zap-upto-char)

; (require 'vip)  ;; for vip-paren-match
(global-set-key '[S-delete] 'kill-lines)
(global-set-key '[M-delete] 'kill-sexp)

(global-set-key '[S-insert] 'yank-lines)

(global-set-key '[M-backspace] 'backward-kill-sexp)

;(global-set-key '[C-up]        "\M-p")
;(global-set-key '[C-down]      "\M-n")
(global-set-key '[M-left]      "\M-\C-b")
(global-set-key '[M-right]     "\M-\C-f")
(global-set-key '[M-up]        'ScrollUp)
(global-set-key '[M-down]      'ScrollDown)

(global-set-key '[C-prior]     'beginning-of-buffer)
(global-set-key '[M-prior]     "\M-0\C-l")
(global-set-key '[C-next]      'end-of-buffer)
(global-set-key '[M-next]      'CenterDown)
(global-set-key '[C-home]      "\M-0\C-k")
(global-set-key '[C-end]       'kill-line)
; (global-set-key '[S-?\C-e] 'word-search-forward)

;; KEYS FOR X
(if window-system
   (progn
      (global-set-key "\M-L" 'hilit-highlight-buffer)
      (global-set-key "\C-z" 'ctl-x-5-prefix)
      (define-key ctl-x-5-map "i" 'iconify-frame)
;     (define-key ctl-x-5-map  '[return] 'vip-change-mode-to-vi )
      (global-set-key "\C-z\C-hf"   'symbol-function-screen)
      (global-set-key "\C-zk"       'kill-buffer-remove-frame)
))

(global-set-key '[M-return]  'delete-forward-whitespace)
(global-set-key "\M-\C-m"    'delete-forward-whitespace)

(global-set-key '[M-kp]'        'digit-argument)
;(keyboard-translate kp-divide ?/)
;(global-set-key '[M-kp-divide]' "\M-/")
;(global-set-key '[M-kp-0] "\M-0")
;(global-set-key '[M-kp-1] "\M-1")
;(global-set-key '[M-kp-2] "\M-2")
;(global-set-key '[M-kp-3] "\M-3")
;(global-set-key '[M-kp-4] "\M-4")
;(global-set-key '[M-kp-5] "\M-5")
;(global-set-key '[M-kp-6] "\M-6")
;(global-set-key '[M-kp-7] "\M-7")
;(global-set-key '[M-kp-8] "\M-8")
;(global-set-key '[M-kp-9] "\M-9")


;(global-set-key '[178] 'vip-paren-match)

(global-set-key '[C-f5] 'SetPointF5  )
(global-set-key '[f5]   'JumpPointF5 )
(global-set-key '[C-f6] 'SetPointF6  )
(global-set-key '[f6]   'JumpPointF6 )
(global-set-key '[C-f7] 'SetPointF7  )
(global-set-key '[f7]   'JumpPointF7 )
(global-set-key '[C-f8] 'SetPointF8  )
(global-set-key '[f8]   'JumpPointF8 )


(defun SetPointF5  () (interactive) (set-mark (point))(point-to-register 'f5))
(defun JumpPointF5 () (interactive) (set-mark (point))(register-to-point 'f5))
(defun SetPointF6  () (interactive) (set-mark (point))(point-to-register 'f6))
(defun JumpPointF6 () (interactive) (set-mark (point))(register-to-point 'f6))
(defun SetPointF7  () (interactive) (set-mark (point))(point-to-register 'f7))
(defun JumpPointF7 () (interactive) (set-mark (point))(register-to-point 'f7))
(defun SetPointF8  () (interactive) (set-mark (point))(point-to-register 'f8))
(defun JumpPointF8 () (interactive) (set-mark (point))(register-to-point 'f8))

(defun kill-lines (lines)
   "Delete ARG lines and put them into the cut-buffer"
   (interactive "p")
   (save-excursion
      (beginning-of-line)
      (let ((beg (point)))
         (forward-line lines)
         (kill-region beg (point))))
   (message "killed %d line(s)" lines)
)

(defun yank-lines (lines)
   "Yank ARG lines into the cut-buffer"
   (interactive "p")
   (save-excursion
      (beginning-of-line)
      (let ((beg (point)))
         (forward-line lines)
         (kill-ring-save beg (point))))
   (message "yanked %d line(s)" lines)
)

(defun ScrollUp (lines)
   "Scroll whole screen up ARG lines"
   (interactive "p")
   (scroll-up lines))

(defun ScrollDown (lines)
   "Scroll whole screen down ARG lines"
   (interactive "p")
   (scroll-down lines))

(defun CenterDown (arg)
   "Makes current line the ARG last one on the screen"
   (interactive "P")
   (recenter (- (window-height) 2 (or arg 0))))

(defun WhatCursorPosition ()
  "Print info on cursor position (on screen and within buffer)."
  (interactive)
  (let* ((char (following-char))
         (beg (point-min))
         (end (point-max))
	 (linep (save-excursion
                   (beginning-of-line)
                   (1+ (count-lines 1 (point)))))
         (pos (point))
         (total (buffer-size))
         (percent (if (> total 50000)
                      ;; Avoid overflow from multiplying by 100!
                      (/ (+ (/ total 200) (1- pos)) (max (/ total 100) 1))
                    (/ (+ (/ total 2) (* 100 (1- pos))) (max total 1))))
         (hscroll (if (= (window-hscroll) 0)
                      ""
                    (format " Hscroll=%d" (window-hscroll))))
         (col (current-column)))
    (if (= pos end)
        (if (or (/= beg 1) (/= end (1+ total)))
            (message "point=%d of %d(%d%%) <%d - %d> line %d column %d %s"
                     pos total percent beg end linep col hscroll)
          (message "point=%d of %d(%d%%)  line %d column %d %s"
                   pos total percent linep col hscroll))
      (if (or (/= beg 1) (/= end (1+ total)))
          (message "Char: %s (0x%02x)  point=%d of %d(%d%%) <%d - %d>  column %d %s"
                   (single-key-description char) char pos total percent beg end col hscroll)
        (message "Char: %s (0x%02x)  point=%d of %d(%d%%) line %d column %d %s"
                 (single-key-description char) char pos total percent linep col hscroll)))))

(defun delete-forward-whitespace ()
   "Delete all spaces and tabs following a point, leaving one space."
   (interactive "*")
   (delete-region (point) (progn (skip-chars-forward " \t\n") (point))))

(defun zap-upto-char (arg char)
  "Kill up to and excluding ARG'th occurrence of CHAR.
Goes backward if ARG is negative; error if CHAR not found."
  (interactive "p\ncZap to char: ")
  (kill-region (point) (progn
			 (search-forward (char-to-string char) nil nil arg)
			 (goto-char (if (> arg 0) (1- (point)) (1+ (point))))
			 (point))))

;; (if window-system
;;     (progn
      (defun symbol-function-screen (fun)
	"Go to the Defun buffer and display function definition at its end. Prettyprint code still needs a LOT of improvement"
	(interactive "aDefinition of function: ")
;
        (display-buffer-other-frame (set-buffer (get-buffer-create "*Defun*")))
	(goto-char (point-max))
	(newline)
	(let ((pos (point)))
	  (insert (prin1-to-string (symbol-function fun)))
	  (goto-char pos)
	  (replace-regexp ")+" "\\&\n")
	  (goto-char pos)
	  (indent-sexp)
	  )
	)
;;       ))

(defun kill-buffer-remove-frame ()
   (interactive)
   (and (kill-buffer nil) (delete-frame)))

; Tons own version of the linux function-key-map:
; (defvar linux-key-map
(setq linux-key-map
      '(keymap
	(27 keymap
	    (91 keymap
		(91 keymap (69 . [f5])
		    (68 . [f4])
		    (67 . [f3])
		    (66 . [f2])
		    (65 . [f1])
                )
 		(87 . [C-f5]	) 	; emacs keymap F29 .W
		(86 . [M-down]  )	; emacs keymap F25 .V
		(85 . [M-next]  )	; emacs keymap F26 .U
		(84 . [M-prior] )	; emacs keymap F27 .T
		(83 . [C-f8]    )	; emacs keymap F32 .S
		(82 . [C-f7]    )	; emacs keymap F31 .R
		(81 . [C-f6]    )	; emacs keymap F30 .Q
		(80 . [M-up]    )	; emacs keymap Pause .
		(79 . [C-home])		; emacs keymap Do    .
		(78 . [S-insert])	; emacs keymap Help  .
                (77 . [S-delete])	; emacs keymap Macro .
		(68 . [left])
		(67 . [right])
		(66 . [down])
		(65 . [up])
		(54 keymap
		    (126 . [next]))
		(53 keymap
		    (126 . [prior]))
		(52 keymap
		    (126 . [end]))
		(51 keymap
		    (126 . [delete])
;		    (52 keymap (126 . [f20]))
		    (51 keymap (126 . [f19]))
		    (50 keymap (126 . [f18]))
		    (49 keymap (126 . [f17]))
		    (48 keymap (126 . [f16]))
                )
		(50 keymap
		    (126 . [insert])
		    (57 keymap (126 . [f16]))
		    (56 keymap (126 . [f15]))
		    (54 keymap (126 . [f14]))
		    (53 keymap (126 . [f13]))
		    (52 keymap (126 . [f12]))
		    (51 keymap (126 . [f11]))
		    (49 keymap (126 . [f10]))
		    (48 keymap (126 . [f9]))
                )
		(49 keymap
		    (126 . [home])
		    (57 keymap (126 . [f8]))
		    (56 keymap (126 . [f7]))
		    (55 keymap (126 . [f6]))
		)
;               (88 . [M-up])           ; emacs keymap KP_Comma
;	        (89 . [M-down])         ; emacs keymap KP_MinPlus
;		(97 . [M-prior])        ; emacs keymap dead_grave
;		(98 . [M-next])         ; emacs keymap dead_acute
;		(99 . [M-down])         ; emacs keymap dead_circumflex
;		(100 . [M-down])        ; emacs keymap dead_tilde
;		(101 . [M-down])        ; emacs keymap dead_diaeresis
	))
	(kp-equal . [61])
	(kp-divide . [47])
	(kp-decimal . [46])
	(kp-subtract . [45])
	(kp-separator . [44])
	(kp-add . [43])
	(kp-multiply . [42])
	(kp-enter . [13])
	(kp-tab . [9])
	(kp-space . [32])
	(kp-9 . [57])
	(kp-8 . [56])
	(kp-7 . [55])
	(kp-6 . [54])
	(kp-5 . [53])
	(kp-4 . [52])
	(kp-3 . [51])
	(kp-2 . [50])
	(kp-1 . [49])
	(kp-0 . [48])
	(help      . "")
        (return    . "\r")
        (escape    . "\e")
        (tab       . "\t")
        (backspace . "\177"))
;      "A keymap that works tolerably well on linux"
)

(provide 'local-keys)
